#pragma once

#include <string>
#include "imgui.h"

extern int init_imgui();
extern void configure_imgui(ImGuiIO& io);
extern bool imgui_new_frame();
extern void draw_imgui(float delta_time);
extern void render_imgui();
extern void shutdown_imgui();

extern void tick_imgui(float delta_time);

inline void run_imgui() {
    init_imgui();
    while (true) {
        if (!imgui_new_frame()) {
            break;
        }
        ImGuiIO& io = ImGui::GetIO();
        tick_imgui(io.DeltaTime);
        draw_imgui(io.DeltaTime);
        render_imgui();
    }
    shutdown_imgui();
}

extern std::string get_window_title();
